﻿Imports System
Imports System.Collections.Generic
Imports System.Web
Imports Telerik.Web.UI

''' <summary>
''' Summary description for AppointmentInfo
''' </summary>
Public Class AppointmentInfo
    Private ReadOnly _id As String
    Private _subject As String
    Private _appointmentColor As String
    Private _start As DateTime
    Private _end As DateTime
    Private _recurrenceRule As String
    Private _recurrenceParentId As String
    Private _reminder As String
    Private _timeZoneID As String
    Private _userID As System.Nullable(Of Integer)

    Public ReadOnly Property ID() As String
        Get
            Return _id
        End Get
    End Property

    Public Property Subject() As String
        Get
            Return _subject
        End Get
        Set(value As String)
            _subject = value
        End Set
    End Property
    Public Property AppointmentColor() As String
        Get
            Return _appointmentColor
        End Get
        Set(value As String)
            _appointmentColor = value
        End Set
    End Property

    Public Property Start() As DateTime
        Get
            Return _start
        End Get
        Set(value As DateTime)
            _start = value
        End Set
    End Property

    Public Property [End]() As DateTime
        Get
            Return _end
        End Get
        Set(value As DateTime)
            _end = value
        End Set
    End Property

    Public Property RecurrenceRule() As String
        Get
            Return _recurrenceRule
        End Get
        Set(value As String)
            _recurrenceRule = value
        End Set
    End Property

    Public Property RecurrenceParentID() As String
        Get
            Return _recurrenceParentId
        End Get
        Set(value As String)
            _recurrenceParentId = value
        End Set
    End Property

    Public Property UserID() As System.Nullable(Of Integer)
        Get
            Return _userID
        End Get
        Set(value As System.Nullable(Of Integer))
            _userID = value
        End Set
    End Property

    Public Property Reminder() As String
        Get
            Return _reminder
        End Get
        Set(value As String)
            _reminder = value
        End Set
    End Property

    Public Property TimeZoneID() As String
        Get
            Return _timeZoneID
        End Get
        Set(value As String)
            _timeZoneID = value
        End Set
    End Property

    Private Sub New()
        _id = Guid.NewGuid().ToString()
    End Sub

    Public Sub New(subject As String, appointmentColor As String, start As DateTime, [end] As DateTime, recurrenceRule As String, recurrenceParentID As String, _
     reminder As String, timeZoneID As String, userID As System.Nullable(Of Integer))
        Me.New()
        _subject = subject
        _appointmentColor = appointmentColor
        _start = start
        _end = [end]
        _recurrenceRule = recurrenceRule
        _recurrenceParentId = recurrenceParentID
        _reminder = reminder
        _timeZoneID = timeZoneID
        _userID = userID
    End Sub
    Public Sub New(subject As String, start As DateTime, [end] As DateTime)
        Me.New()
        Me.Subject = subject
        Me.Start = start
        Me.[End] = [end]
    End Sub

    Public Sub New(source As Appointment)
        Me.New()
        CopyInfo(source)
    End Sub

    Public Sub CopyInfo(source As Appointment)
        Subject = source.Subject
        AppointmentColor = source.Attributes("AppointmentColor")
        Start = source.Start
        [End] = source.[End]
        TimeZoneID = source.TimeZoneID
        RecurrenceRule = source.RecurrenceRule
        If source.RecurrenceParentID IsNot Nothing Then
            RecurrenceParentID = source.RecurrenceParentID.ToString()
        End If

        If Not [String].IsNullOrEmpty(Reminder) Then
            Reminder = source.Reminders(0).ToString()
        End If

        Dim user As Resource = source.Resources.GetResourceByType("User")
        If user IsNot Nothing Then
            UserID = DirectCast(user.Key, System.Nullable(Of Integer))
        Else
            UserID = Nothing
        End If
    End Sub
End Class
